"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var jestConfig = tslib_1.__importStar(require("jest-config"));
var logger_1 = require("../util/logger");
var logger = logger_1.rootLogger.child({ namespace: 'jest-preset' });
// jest 22 doesn't have defaults
var defaults = jestConfig.defaults || {
    transform: null,
    testMatch: ['**/__tests__/**/*.js?(x)', '**/?(*.)+(spec|test).js?(x)'],
    moduleFileExtensions: ['js', 'json', 'jsx', 'node'],
};
// TODO: find out if tsconfig that we'll use contains `allowJs`
// and change the transform so that it also uses ts-jest for js files
function createJestPreset(_a) {
    var _b = (_a === void 0 ? {} : _a).allowJs, allowJs = _b === void 0 ? false : _b;
    var _c;
    logger.debug({ allowJs: allowJs }, 'creating jest presets', allowJs ? 'handling' : 'not handling', 'JavaScript files');
    return {
        transform: tslib_1.__assign({}, defaults.transform, (_c = {}, _c[allowJs ? '^.+\\.[tj]sx?$' : '^.+\\.tsx?$'] = 'ts-jest', _c)),
        testMatch: tslib_1.__spread(defaults.testMatch, [
            '**/__tests__/**/*.ts?(x)',
            '**/?(*.)+(spec|test).ts?(x)',
        ]),
        moduleFileExtensions: tslib_1.__spread(defaults.moduleFileExtensions, ['ts', 'tsx']),
    };
}
exports.createJestPreset = createJestPreset;
//# sourceMappingURL=create-jest-preset.js.map