"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var ts_jest_transformer_1 = require("./ts-jest-transformer");
var create_jest_preset_1 = require("./config/create-jest-preset");
exports.createJestPreset = create_jest_preset_1.createJestPreset;
var version_checkers_1 = require("./util/version-checkers");
var paths_to_module_name_mapper_1 = require("./config/paths-to-module-name-mapper");
exports.pathsToModuleNameMapper = paths_to_module_name_mapper_1.pathsToModuleNameMapper;
// tslint:disable-next-line:no-var-requires
var version = require('../package.json').version;
exports.version = version;
var transformer;
function defaultTransformer() {
    return transformer || (transformer = createTransformer());
}
function createTransformer(baseConfig) {
    version_checkers_1.VersionCheckers.jest.warn();
    return new ts_jest_transformer_1.TsJestTransformer(baseConfig);
}
exports.createTransformer = createTransformer;
function tsProcess() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var _a;
    return (_a = defaultTransformer()).process.apply(_a, tslib_1.__spread(args));
}
exports.process = tsProcess;
function getCacheKey() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var _a;
    return (_a = defaultTransformer()).getCacheKey.apply(_a, tslib_1.__spread(args));
}
exports.getCacheKey = getCacheKey;
var jestPreset = create_jest_preset_1.createJestPreset();
exports.jestPreset = jestPreset;
// for tests
// tslint:disable-next-line:variable-name
var __singleton = function () { return transformer; };
exports.__singleton = __singleton;
// tslint:disable-next-line:variable-name
var __resetModule = function () { return (transformer = undefined); };
exports.__resetModule = __resetModule;
//# sourceMappingURL=index.js.map