"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var semver_1 = tslib_1.__importDefault(require("semver"));
var logger_1 = require("./logger");
var logger = logger_1.rootLogger.child({ namespace: 'hacks' });
// tslint:disable-next-line:variable-name
exports.patchBabelCore_githubIssue6577 = function (babel) {
    // There is an issue still open in Babel 6: https://github.com/babel/babel/issues/6577
    // This is a hack to bypass it and fix our issue #627
    // The bug disallow debugging when using Babel Jest with babel-core@6.x because of
    // source-maps not being inlined
    if (typeof babel.version === 'string' &&
        semver_1.default.satisfies(babel.version, '>=6 <7')) {
        try {
            var File = require('babel-core/lib/transformation/file').File;
            File.prototype.initOptions = (function (original) {
                return function initOptions(opt) {
                    var before = opt.sourceMaps;
                    var result = original.apply(this, arguments);
                    if (before && before !== result.sourceMaps) {
                        result.sourceMaps = before;
                    }
                    return result;
                };
            })(File.prototype.initOptions);
            logger.info('patched babel-core/lib/transformation/file');
        }
        catch (err) { }
    }
    return babel;
};
//# sourceMappingURL=hacks.js.map