"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var util_1 = require("util");
var make_error_1 = require("make-error");
var messages_1 = require("./messages");
var logger_1 = require("./logger");
var logger = logger_1.rootLogger.child({ namespace: 'TSError' });
/**
 * @internal
 */
exports.INSPECT_CUSTOM = util_1.inspect.custom || 'inspect';
/**
 * TypeScript diagnostics error.
 */
var TSError = /** @class */ (function (_super) {
    tslib_1.__extends(TSError, _super);
    function TSError(diagnosticText, diagnosticCodes) {
        var _this = _super.call(this, messages_1.interpolate(messages_1.Errors.UnableToCompileTypeScript, {
            diagnostics: diagnosticText.trim(),
            help: messages_1.Helps.IgnoreDiagnosticCode,
        })) || this;
        _this.diagnosticText = diagnosticText;
        _this.diagnosticCodes = diagnosticCodes;
        _this.name = 'TSError';
        logger.debug({ diagnosticCodes: diagnosticCodes, diagnosticText: diagnosticText }, 'created new TSError');
        // ensure we blacklist any of our code
        Object.defineProperty(_this, 'stack', { value: '' });
        return _this;
    }
    /**
     * @internal
     */
    TSError.prototype[exports.INSPECT_CUSTOM] = function () {
        return this.diagnosticText;
    };
    return TSError;
}(make_error_1.BaseError));
exports.TSError = TSError;
//# sourceMappingURL=ts-error.js.map